window.searchTypes.push({
	'name': 'Confluence',
	'icon': 'confluence/icon.png',
	'maskIcon': true,
	'search': async function(search) {
		var instance = 'https://your-confluence-instance';
		var user = 'your-username';
		var password = window.KeyboardMaestro ? window.KeyboardMaestro.GetVariable('CustomSearchAtlassianPassword') : '';

		if (!instance || !user || !password) {
			throw new Error('Configuration missing.');
		}

		if (search == '') {
			return [];
		}

		var options = {
			headers: {
				'Content-Type': 'application/json',
				'Authorization': 'Basic ' + window.btoa(user + ':' + password)
			}
		};
		// TODO: improve escaping
		var cql;
		var words = search.split(/ +/);
		var text = [];
		var space = null;
		for (var i = 0; i < words.length; i++) {
			var word = words[i];
			if (/^[A-Z]+$/.test(word)) {
				space = word;
			} else {
				text.push(word);
			}
		}
		cql = 'siteSearch ~ "' + text.join(' ').replace(/([\\"])/g, '\\$1') + '"';
		if (space !== null) {
			cql += ' AND space = "' + space + '"'
		}
		var response = await fetch(instance + '/rest/api/content/search?limit=20&cql=' + encodeURIComponent(cql), options);
		if (response.status === 401) {
			throw new Error('Authorization failed.');
		}
		var result = await response.json();

		var output = [];
		var space;
		if (result.results) {
			result.results.forEach(function(result) {
				space = result._expandable.space;
				output.push({
					'title': result.title,
					'url': instance + result._links.webui,
					'badge': space.substring(space.lastIndexOf('/') + 1),
					'icon': 'confluence/' + result.type + '.png'
				});
			});
		}
		return output;
	}
});
