window.searchTypes.push({
	'name': 'iTunes',
	'icon': 'itunes/icon.png',
	'search': async function(search) {
		if (search == '') {
			return [];
		}

		var response = await fetch('https://itunes.apple.com/search?term=' + encodeURIComponent(search) + '&media=music&limit=10');
		var result = await response.json();

		var output = [];
		if (result.results) {
			result.results.forEach(function(result) {
				output.push({
					'title': result.trackName || result.collectionName,
					'subtitle': result.artistName,
					'url': result.trackViewUrl || result.collectionViewUrl,
					'badge': result.primaryGenreName,
					'icon': result.artworkUrl30 || result.artworkUrl60
				});
			});
		}
		return output;
	}
});
