window.searchTypes.push({
	'name': 'JIRA',
	'icon': 'jira/icon.png',
	'maskIcon': true,
	'search': async function(search) {
		var instance = 'https://your-jira-instance';
		var user = 'your-username';
		var password = window.KeyboardMaestro ? window.KeyboardMaestro.GetVariable('CustomSearchAtlassianPassword') : '';

		if (!instance || !user || !password) {
			throw new Error('Configuration missing.');
		}

		if (search == '') {
			return [];
		}

		var options = {
			headers: {
				'Content-Type': 'application/json',
				'Authorization': 'Basic ' + window.btoa(user + ':' + password)
			}
		};
		// TODO: improve escaping
		var jql;
		if (/^[A-Z]+-\d+$/i.test(search)) {
			jql = 'issuekey = "' + search + '"';
		} else {
			var words = search.split(/ +/);
			var text = [];
			var project = null;
			for (var i = 0; i < words.length; i++) {
				var word = words[i];
				if (/^[A-Z]+$/.test(word)) {
					project = word;
				} else {
					text.push(word);
				}
			}
			jql = 'text ~ "' + text.join(' ').replace(/([\\"])/g, '\\$1') + '"';
			if (project !== null) {
				jql += ' AND project = "' + project + '"'
			}
		}
		var response = await fetch(instance + '/rest/api/latest/search?fields=key,summary,description&maxResults=20&jql=' + encodeURIComponent(jql), options);
		if (response.status === 401) {
			throw new Error('Authorization failed.');
		}
		var result = await response.json();

		var output = [];
		if (result.issues) {
			result.issues.forEach(function(issue) {
				output.push({
					'title': issue.fields.summary,
					'subtitle': issue.fields.description || '',
					'url': instance + '/browse/' + issue.key,
					'badge': issue.key,
					'icon': 'jira/document.png'
				});
			});
		}
		return output;
	}
});
