window.searchTypes.push({
	'name': 'Wikipedia',
	'icon': 'wikipedia/icon.png',
	'maskIcon': true,
	'search': async function(search) {
		var instance = 'https://en.wikipedia.org';

		if (search == '') {
			return [];
		}

		var response = await fetch(instance + '/w/api.php?action=query&list=search&srwhat=text&format=json&srsearch=' + encodeURIComponent(search));
		var result = await response.json();

		var output = [];
		if (result.query && result.query.search) {
			result.query.search.forEach(function(item) {
				output.push({
					'title': item.title,
					'subtitleHTML': item.snippet,
					'url': 'https://en.wikipedia.org/wiki/' + encodeURIComponent(item.title.replace(/ /g, '_')),
					'icon': 'wikipedia/document.png'
				});
			});
		}
		return output;
	}
});
